//+------------------------------------------------------------------+
//|                                           Plot_External_Data.mq4 |
//|                                                   David Louisson |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "David Louisson"
#property link      "http://www.metaquotes.net"

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  Red
#property  indicator_width1  1

//---- indicator parameters
extern   string   FileName          = "EXPORT";   // News file name

//---- indicator buffers
double     ind_buffer1[];

datetime   xDateTime[9999];
double     xValue[9999];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   ArrayInitialize(ind_buffer1,EMPTY_VALUE);
   SetIndexBuffer(0,ind_buffer1);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID);
   SetIndexDrawBegin(0,0);
   IndicatorShortName("External: "+FileName);

   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int handle = FileOpen(FileName, FILE_CSV|FILE_READ,',');
   if(handle==0)
      Comment("File "+FileName+" not found.");

   for(int c=0; !FileIsEnding(handle); c++)
   {
      string xDate = FileReadString(handle);
      string xTime = FileReadString(handle);
      if (FileIsEnding(handle)) break;
      xDateTime[c] = StrToTime(xDate+" "+xTime);
      xValue[c]    = StrToDouble(FileReadString(handle));
//      Print(c+"  "+TimeToStr(xDateTime[c],TIME_DATE|TIME_SECONDS)+"  "+DoubleToStr(xValue[c],4));
   }
   c--;
   for (int i=0; i<=Bars; i++)
     {
       while(Time[i] < xDateTime[c]) c--;
       if (c >= 0) ind_buffer1[i] = xValue[c];
//       Print(i+"  "+c+"  "+TimeToStr(Time[i])+"  "+TimeToStr(xDateTime[c])+"  "+DoubleToStr(xValue[c],4)+"  "+DoubleToStr(ind_buffer1[i],4));
     }
   FileClose(handle);
    
//---- done
   return(0);
  }